diff --git a/js/src/tests/lib/progressbar.py b/js/src/tests/lib/progressbar.py
index da578783df..bdd7369e90 100644
--- a/js/src/tests/lib/progressbar.py
+++ b/js/src/tests/lib/progressbar.py
@@ -5,9 +5,9 @@ import math
 import sys
 
 if sys.platform.startswith('win'):
-    from terminal_win import Terminal
+    from .terminal_win import Terminal
 else:
-    from terminal_unix import Terminal
+    from .terminal_unix import Terminal
 
 class NullProgressBar(object):
     def update(self, current, data): pass
diff --git a/js/src/tests/lib/results.py b/js/src/tests/lib/results.py
index 451fe5b657..1598789233 100644
--- a/js/src/tests/lib/results.py
+++ b/js/src/tests/lib/results.py
@@ -1,7 +1,7 @@
 from __future__ import print_function
 
 import re
-from progressbar import NullProgressBar, ProgressBar
+from .progressbar import NullProgressBar, ProgressBar
 import pipes
 
 # subprocess.list2cmdline does not properly escape for sh-like shells
@@ -131,7 +131,7 @@ class ResultsSink:
             dev_label = self.LABELS[tup][1]
 
             if self.options.check_output:
-                if output.test.path in self.output_dict.keys():
+                if output.test.path in list(self.output_dict.keys()):
                     if self.output_dict[output.test.path] != output:
                         self.counts['FAIL'] += 1
                         self.print_automation_result(
diff --git a/js/src/tests/lib/tasks_unix.py b/js/src/tests/lib/tasks_unix.py
index 487c749ee2..433e47d4aa 100644
--- a/js/src/tests/lib/tasks_unix.py
+++ b/js/src/tests/lib/tasks_unix.py
@@ -2,10 +2,11 @@
 # waitpid to dispatch tasks.  This avoids several deadlocks that are possible
 # with fork/exec + threads + Python.
 
+from __future__ import print_function
 import errno, os, select, sys
 from datetime import datetime, timedelta
-from progressbar import ProgressBar
-from results import NullTestOutput, TestOutput, escape_cmdline
+from .progressbar import ProgressBar
+from .results import NullTestOutput, TestOutput, escape_cmdline
 
 class Task(object):
     def __init__(self, test, prefix, pid, stdout, stderr):
@@ -25,7 +26,7 @@ def spawn_test(test, prefix, passthrough, run_skipped, show_cmd):
 
     cmd = test.get_command(prefix)
     if show_cmd:
-        print(escape_cmdline(cmd))
+        print((escape_cmdline(cmd)))
 
     if not passthrough:
         (rout, wout) = os.pipe()
@@ -107,7 +108,7 @@ def read_input(tasks, timeout):
     try:
         readable, _, _ = select.select(rlist, [], exlist, timeout)
     except OverflowError as e:
-        print >> sys.stderr, "timeout value", timeout
+        print("timeout value", timeout, file=sys.stderr)
         raise
 
     for fd in readable:
diff --git a/js/src/tests/lib/tasks_win.py b/js/src/tests/lib/tasks_win.py
index a99640abbf..e091775578 100644
--- a/js/src/tests/lib/tasks_win.py
+++ b/js/src/tests/lib/tasks_win.py
@@ -6,10 +6,10 @@ from __future__ import print_function, unicode_literals, division
 import subprocess
 import sys
 from datetime import datetime, timedelta
-from progressbar import ProgressBar
-from results import NullTestOutput, TestOutput, escape_cmdline
+from .progressbar import ProgressBar
+from .results import NullTestOutput, TestOutput, escape_cmdline
 from threading import Thread
-from Queue import Queue, Empty
+from queue import Queue, Empty
 
 
 class EndMarker:
@@ -22,7 +22,7 @@ class TaskFinishedMarker:
 
 def _do_work(qTasks, qResults, qWatch, prefix, run_skipped, timeout, show_cmd):
     while True:
-        test = qTasks.get(block=True, timeout=sys.maxint)
+        test = qTasks.get(block=True, timeout=sys.maxsize)
         if test is EndMarker:
             qWatch.put(EndMarker)
             qResults.put(EndMarker)
@@ -73,7 +73,7 @@ def _do_watch(qWatch, timeout):
                 # ignore this.
                 if ex.winerror != 5:
                     raise
-            fin = qWatch.get(block=True, timeout=sys.maxint)
+            fin = qWatch.get(block=True, timeout=sys.maxsize)
             assert fin is TaskFinishedMarker, "invalid finish marker"
 
 
diff --git a/js/src/tests/lib/tests.py b/js/src/tests/lib/tests.py
index 1de56dc1c4..af31f9a7eb 100644
--- a/js/src/tests/lib/tests.py
+++ b/js/src/tests/lib/tests.py
@@ -3,12 +3,13 @@
 # This contains classes that represent an individual test, including
 # metadata, and know how to run the tests and determine failures.
 
+from __future__ import print_function
 import datetime, os, sys, time
 from contextlib import contextmanager
 from subprocess import Popen, PIPE
 from threading import Thread
 
-from results import TestOutput
+from .results import TestOutput
 
 # When run on tbpl, we run each test multiple times with the following
 # arguments.
@@ -43,14 +44,14 @@ JITFLAGS = {
 
 def get_jitflags(variant, **kwargs):
     if variant not in JITFLAGS:
-        print('Invalid jitflag: "{}"'.format(variant))
+        print(('Invalid jitflag: "{}"'.format(variant)))
         sys.exit(1)
     if variant == 'none' and 'none' in kwargs:
         return kwargs['none']
     return JITFLAGS[variant]
 
 def valid_jitflags():
-    return JITFLAGS.keys()
+    return list(JITFLAGS.keys())
 
 def get_environment_overlay(js_shell):
     """
diff --git a/js/src/tests/parsemark.py b/js/src/tests/parsemark.py
index 5c2fa4a71f..13420fba97 100644
--- a/js/src/tests/parsemark.py
+++ b/js/src/tests/parsemark.py
@@ -96,7 +96,7 @@ def parsemark(filepaths, fbench, stfu=False):
             print('Parsemarking {}...'.format(filename))
         bench_map[filename] = fbench(filepath)
     print('{')
-    for i, (filename, (avg, stddev)) in enumerate(bench_map.iteritems()):
+    for i, (filename, (avg, stddev)) in enumerate(bench_map.items()):
         assert '"' not in filename
         fmt = '    {:30s}: {{"average_ms": {:6.2f}, "stddev_ms": {:6.2f}}}'
         if i != len(bench_map) - 1:
@@ -105,7 +105,7 @@ def parsemark(filepaths, fbench, stfu=False):
         print(fmt.format(filename_str, avg, stddev))
     print('}')
     return dict((filename, dict(average_ms=avg, stddev_ms=stddev))
-                for filename, (avg, stddev) in bench_map.iteritems())
+                for filename, (avg, stddev) in bench_map.items())
 
 
 def main():
diff --git a/js/src/vm/make_opcode_doc.py b/js/src/vm/make_opcode_doc.py
index 454d8b8d5e..b30e8ce6f6 100755
--- a/js/src/vm/make_opcode_doc.py
+++ b/js/src/vm/make_opcode_doc.py
@@ -275,20 +275,18 @@ def print_opcode(opcode):
     names_template = '{name} [-{nuses}, +{ndefs}]{flags}'
     opcodes = sorted([opcode] + opcode.group,
                      key=lambda opcode: opcode.name)
-    names = map(lambda code: names_template.format(name=escape(code.name),
+    names = [names_template.format(name=escape(code.name),
                                                    nuses=override(code.nuses,
                                                                   opcode.nuses_override),
                                                    ndefs=override(code.ndefs,
                                                                   opcode.ndefs_override),
-                                                   flags=format_flags(code.flags)),
-                opcodes)
+                                                   flags=format_flags(code.flags)) for code in opcodes]
     if len(opcodes) == 1:
         values = ['{value} (0x{value:02x})'.format(value=opcode.value)]
     else:
         values_template = '{name}: {value} (0x{value:02x})'
-        values = map(lambda code: values_template.format(name=escape(code.name),
-                                                         value=code.value),
-                    opcodes)
+        values = [values_template.format(name=escape(code.name),
+                                                         value=code.value) for code in opcodes]
 
     print("""<dt id="{id}">{names}</dt>
 <dd>
diff --git a/js/src/vm/make_unicode.py b/js/src/vm/make_unicode.py
index 8568ccb64c..9f96543a4c 100755
--- a/js/src/vm/make_unicode.py
+++ b/js/src/vm/make_unicode.py
@@ -27,8 +27,10 @@ import os
 import sys
 from contextlib import closing
 from functools import partial
-from itertools import chain, groupby, ifilter, imap, izip_longest, tee
+from itertools import chain, groupby, tee
 from operator import is_not, itemgetter
+import six
+from itertools import zip_longest
 
 class codepoint_dict(dict):
     def name(self, code_point):
@@ -103,12 +105,12 @@ def read_unicode_data(unicode_data):
     reader = csv.reader(unicode_data, delimiter=';')
 
     while True:
-        row = reader.next()
+        row = next(reader)
         name = row[1]
 
         # We need to expand the UAX #44 4.2.3 Code Point Range
         if name.startswith('<') and name.endswith('First>'):
-            next_row = reader.next()
+            next_row = next(reader)
 
             for i in range(int(row[0], 16), int(next_row[0], 16) + 1):
                 row[0] = i
@@ -172,7 +174,7 @@ def int_ranges(ints):
     """ Yields consecutive ranges (inclusive) from integer values. """
     (a, b) = tee(sorted(ints))
     start = next(b)
-    for (curr, succ) in izip_longest(a, b):
+    for (curr, succ) in zip_longest(a, b):
         if curr + 1 != succ:
             yield (start, curr)
             start = succ
@@ -527,16 +529,16 @@ def process_special_casing(special_casing, table, index):
         return upper
 
     def ascii(char_dict):
-        return ifilter(lambda ch: ch <= 0x7f, char_dict.iterkeys())
+        return filter(lambda ch: ch <= 0x7f, char_dict.keys())
 
     def latin1(char_dict):
-        return ifilter(lambda ch: ch <= 0xff, char_dict.iterkeys())
+        return filter(lambda ch: ch <= 0xff, char_dict.keys())
 
     def is_empty(iterable):
         return not any(True for _ in iterable)
 
     def is_equals(iter1, iter2):
-        return all(x == y for (x, y) in izip_longest(iter1, iter2))
+        return all(x == y for (x, y) in zip_longest(iter1, iter2))
 
     # Ensure no ASCII characters have special case mappings.
     assert is_empty(ascii(unconditional_tolower))
@@ -567,28 +569,28 @@ def process_special_casing(special_casing, table, index):
     assert all(ch != lowerCase(ch) for ch in [0x0130, 0x03A3])
 
     # Ensure Azeri, Lithuanian, and Turkish are the only languages with conditional case mappings.
-    assert is_equals(["az", "lt", "tr"], sorted(lang_conditional_tolower.iterkeys()))
-    assert is_equals(["az", "lt", "tr"], sorted(lang_conditional_toupper.iterkeys()))
+    assert is_equals(["az", "lt", "tr"], sorted(lang_conditional_tolower.keys()))
+    assert is_equals(["az", "lt", "tr"], sorted(lang_conditional_toupper.keys()))
 
     # Maximum case mapping length is three characters.
-    itervals = lambda d: d.itervalues()
-    assert max(imap(len, chain(
+    itervals = lambda d: d.values()
+    assert max(map(len, chain(
         itervals(unconditional_tolower),
         itervals(unconditional_toupper),
-        imap(itemgetter(0), itervals(conditional_tolower)),
-        imap(itemgetter(0), itervals(conditional_toupper)),
-        imap(itemgetter(0), chain.from_iterable(imap(itervals, itervals(lang_conditional_tolower)))),
-        imap(itemgetter(0), chain.from_iterable(imap(itervals, itervals(lang_conditional_toupper)))),
+        map(itemgetter(0), itervals(conditional_tolower)),
+        map(itemgetter(0), itervals(conditional_toupper)),
+        map(itemgetter(0), chain.from_iterable(map(itervals, itervals(lang_conditional_tolower)))),
+        map(itemgetter(0), chain.from_iterable(map(itervals, itervals(lang_conditional_toupper)))),
     ))) <= 3
 
     # Ensure all case mapping contexts are known (see Unicode 9.0, §3.13 Default Case Algorithms).
     assert set([
         'After_I', 'After_Soft_Dotted', 'Final_Sigma', 'More_Above', 'Not_Before_Dot',
-    ]).issuperset(set(ifilter(partial(is_not, None), chain(
-        imap(itemgetter(1), itervals(conditional_tolower)),
-        imap(itemgetter(1), itervals(conditional_toupper)),
-        imap(itemgetter(1), chain.from_iterable(imap(itervals, itervals(lang_conditional_tolower)))),
-        imap(itemgetter(1), chain.from_iterable(imap(itervals, itervals(lang_conditional_toupper)))),
+    ]).issuperset(set(filter(partial(is_not, None), chain(
+        map(itemgetter(1), itervals(conditional_tolower)),
+        map(itemgetter(1), itervals(conditional_toupper)),
+        map(itemgetter(1), chain.from_iterable(map(itervals, itervals(lang_conditional_tolower)))),
+        map(itemgetter(1), chain.from_iterable(map(itervals, itervals(lang_conditional_toupper)))),
     ))))
 
     # Special casing for U+00DF (LATIN SMALL LETTER SHARP S).
@@ -677,7 +679,7 @@ def write_special_casing_methods(unconditional_toupper, codepoint_table, println
                 lines[-1].append(expr)
             else:
                 lines.append([expr])
-        return ' ||\n{}'.format(spaces).join(imap(lambda t: ' || '.join(t), lines))
+        return ' ||\n{}'.format(spaces).join(map(lambda t: ' || '.join(t), lines))
 
     def write_range_accept(parent_list, child_list, depth):
         """ Accepts the input character if it matches any code unit in |child_list|. """
@@ -732,7 +734,7 @@ def write_special_casing_methods(unconditional_toupper, codepoint_table, println
         assert unconditional_toupper, "|unconditional_toupper| is not empty"
 
         # Sorted list of code units with special upper case mappings.
-        code_list = sorted(unconditional_toupper.iterkeys())
+        code_list = sorted(unconditional_toupper.keys())
 
         # Fail-fast if the input character isn't a special casing character.
         println('    if ({})'.format(out_range(code_list[0], code_list[-1])))
@@ -787,7 +789,7 @@ def write_special_casing_methods(unconditional_toupper, codepoint_table, println
         println('{')
 
         println('    switch(ch) {')
-        for (code, converted) in sorted(unconditional_toupper.iteritems(), key=itemgetter(0)):
+        for (code, converted) in sorted(unconditional_toupper.items(), key=itemgetter(0)):
             println('      case {}: return {}; // {}'.format(hexlit(code), len(converted),
                                                              codepoint_table.name(code)))
         println('    }')
@@ -804,7 +806,7 @@ def write_special_casing_methods(unconditional_toupper, codepoint_table, println
         println('{')
 
         println('    switch(ch) {')
-        for (code, converted) in sorted(unconditional_toupper.iteritems(), key=itemgetter(0)):
+        for (code, converted) in sorted(unconditional_toupper.items(), key=itemgetter(0)):
             println('      case {}: // {}'.format(hexlit(code), codepoint_table.name(code)))
             for ch in converted:
                 println('        elements[(*index)++] = {}; // {}'.format(hexlit(ch),
@@ -843,8 +845,8 @@ def make_bmp_mapping_test(version, codepoint_table, unconditional_tolower, uncon
                 (upper, lower, _, _) = entry
                 upper = unconditional_toupper[code] if code in unconditional_toupper else [upper]
                 lower = unconditional_tolower[code] if code in unconditional_tolower else [lower]
-                println('  ["{}", "{}"], /* {} */'.format("".join(imap(unicodeEsc, upper)),
-                                                          "".join(imap(unicodeEsc, lower)),
+                println('  ["{}", "{}"], /* {} */'.format("".join(map(unicodeEsc, upper)),
+                                                          "".join(map(unicodeEsc, lower)),
                                                           codepoint_table.name(code)))
             else:
                 println('  ["{0}", "{0}"],'.format(unicodeEsc(code)))
@@ -1072,7 +1074,7 @@ def make_unicode_file(version,
         println('bool')
         println('js::unicode::{}(uint32_t codePoint)'.format(name))
         println('{')
-        for (from_code, to_code) in int_ranges(group_set.keys()):
+        for (from_code, to_code) in int_ranges(list(group_set.keys())):
             println('    if (codePoint >= 0x{:X} && codePoint <= 0x{:X}) // {} .. {}'.format(from_code,
                                                                                              to_code,
                                                                                              codepoint_table.name(from_code),
@@ -1117,7 +1119,7 @@ def make_unicode_file(version,
         # If the following assert fails, it means space character is added to
         # non-BMP area.  In that case the following code should be uncommented
         # and the corresponding code should be added to frontend.
-        assert len(non_bmp_space_set.keys()) == 0
+        assert len(list(non_bmp_space_set.keys())) == 0
 
         write_supplemental_identifier_method('IsIdentifierStartNonBMP', non_bmp_id_start_set,
                                              println)
@@ -1277,20 +1279,20 @@ def make_irregexp_tables(version,
         # Latin1 characters which, when case-mapped through
         # String.prototype.toUpperCase(), canonicalize to a non-Latin1 character.
         # ES2017, §21.2.2.8.2 Runtime Semantics: Canonicalize
-        casemapped_to_nonlatin1 = ifilter(casemaps_to_nonlatin1, xrange(0, MAX_LATIN1 + 1))
+        casemapped_to_nonlatin1 = filter(casemaps_to_nonlatin1, range(0, MAX_LATIN1 + 1))
 
         def casemap_closure(ch):
             upper = to_upper(ch)
-            return (ch, [c for c in xrange(MAX_LATIN1 + 1, MAX_BMP + 1) if upper == to_upper(c)])
+            return (ch, [c for c in range(MAX_LATIN1 + 1, MAX_BMP + 1) if upper == to_upper(c)])
 
         # Mapping from Latin1 characters to the list of case map equivalent
         # non-Latin1 characters.
-        casemap_for_latin1 = dict(chain(imap(casemap_closure, casemapped_to_nonlatin1)))
+        casemap_for_latin1 = dict(chain(map(casemap_closure, casemapped_to_nonlatin1)))
 
         # Non-latin1 characters which, when Unicode case-folded, canonicalize to
         # a Latin1 character.
         # ES2017, §21.2.2.8.2 Runtime Semantics: Canonicalize
-        casefolded_to_latin1 = ifilter(casefolds_to_latin1, xrange(MAX_LATIN1 + 1, MAX_BMP + 1))
+        casefolded_to_latin1 = filter(casefolds_to_latin1, range(MAX_LATIN1 + 1, MAX_BMP + 1))
 
         println('    if (unicode) {')
         for ch in casefolded_to_latin1:
@@ -1304,11 +1306,11 @@ def make_irregexp_tables(version,
             println('            return {};'.format(consequent(casefolded)))
         println('    }')
         println('')
-        for (ch, casemapped_chars) in casemap_for_latin1.iteritems():
+        for (ch, casemapped_chars) in casemap_for_latin1.items():
             for casemapped in casemapped_chars:
                 println('    // "{}" case maps to "{}".'.format(char_name(casemapped),
                                                                 char_name(ch)))
-            println('    if ({})'.format(' || '.join(imap(test, casemapped_chars))))
+            println('    if ({})'.format(' || '.join(map(test, casemapped_chars))))
             println('        return {};'.format(consequent(ch)))
         println('    return {};'.format(default))
 
@@ -1345,7 +1347,7 @@ def make_irregexp_tables(version,
         character_range = partial(write_character_range, println)
 
         # Characters in \s, 21.2.2.12 CharacterClassEscape.
-        space_chars = filter(is_space, xrange(0, MAX_BMP + 1))
+        space_chars = list(filter(is_space, range(0, MAX_BMP + 1)))
 
         # Characters in \d, 21.2.2.12 CharacterClassEscape.
         digit_chars = map(ord, string.digits)
@@ -1357,10 +1359,10 @@ def make_irregexp_tables(version,
 
         # Characters which case-fold to characters in \w.
         ignorecase_word_chars = (word_chars +
-                                filter(casefolds_to_ascii, xrange(MAX_ASCII + 1, MAX_BMP + 1)))
+                                list(filter(casefolds_to_ascii, range(MAX_ASCII + 1, MAX_BMP + 1))))
 
         # Surrogate characters.
-        surrogate_chars = range(LEAD_SURROGATE_MIN, TRAIL_SURROGATE_MAX + 1)
+        surrogate_chars = list(range(LEAD_SURROGATE_MIN, TRAIL_SURROGATE_MAX + 1))
 
         write(warning_message)
         write(unicode_version_message.format(version))
@@ -1383,7 +1385,7 @@ def make_irregexp_tables(version,
         character_range('IgnoreCaseWord', ignorecase_word_chars)
         character_range('WordAndSurrogate', word_chars + surrogate_chars)
         character_range('NegatedIgnoreCaseWordAndSurrogate',
-                        set(xrange(0, MAX_BMP + 1)) - set(ignorecase_word_chars + surrogate_chars))
+                        set(range(0, MAX_BMP + 1)) - set(ignorecase_word_chars + surrogate_chars))
 
         character_range('Digit', digit_chars)
         character_range('DigitAndSurrogate', digit_chars + surrogate_chars)
@@ -1393,7 +1395,7 @@ def make_irregexp_tables(version,
         character_range('LineTerminator', line_terminator)
 
 def update_unicode(args):
-    import urllib2
+    import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
     version = args.version
     if version is not None:
@@ -1417,7 +1419,7 @@ def update_unicode(args):
         if version is not None:
             print('Downloading %s...' % fname)
             unicode_data_url = '%s/%s' % (url, fname)
-            with closing(urllib2.urlopen(unicode_data_url)) as reader:
+            with closing(six.moves.urllib.request.urlopen(unicode_data_url)) as reader:
                 data = reader.read()
             tfile = io.open(tfile_path, 'w+b')
             tfile.write(data)
diff --git a/layout/generic/frame-graph.py b/layout/generic/frame-graph.py
index ac1076b83c..025ada76d5 100644
--- a/layout/generic/frame-graph.py
+++ b/layout/generic/frame-graph.py
@@ -34,7 +34,7 @@ for line in sys.stdin:
 
 sys.stdout.write('digraph g {\n')
 
-for olist in classdict.itervalues():
+for olist in classdict.values():
     for line in olist:
         sys.stdout.write(line)
 
diff --git a/layout/reftests/border-image/gen-refs.py b/layout/reftests/border-image/gen-refs.py
index 44a89353d1..8850c75ed5 100644
--- a/layout/reftests/border-image/gen-refs.py
+++ b/layout/reftests/border-image/gen-refs.py
@@ -27,6 +27,7 @@
 # Assumes there is no intrinsic size for the border-image-source, so uses
 # the size of the border image area.
 
+from __future__ import print_function
 import sys
 
 class Point:
@@ -65,7 +66,7 @@ class np:
 def parse_p(tok):
   if tok[-2:] == "px":
     return float(tok[:-2])
-  print "Whoops, not a pixel value " + tok
+  print("Whoops, not a pixel value " + tok)
 
 def parse_np(tok):
   if tok[-2:] == "px":
@@ -91,11 +92,11 @@ def parse(filename):
     if toks[0] == "border-image-repeat:":
       props.repeat = toks[1]
     if toks[0] == "border-image-slice:":
-      props.slice = map(parse_p, toks[1:5])
+      props.slice = list(map(parse_p, toks[1:5]))
     if toks[0] == "border-image-width:":
-      props.image_width = map(parse_np, toks[1:5])
+      props.image_width = list(map(parse_np, toks[1:5]))
     if toks[0] == "border-image-outset:":
-      props.outset = map(parse_np, toks[1:5])
+      props.outset = list(map(parse_np, toks[1:5]))
   f.close()
   return props
 
@@ -106,8 +107,8 @@ def normalise(props):
   result = Props()
   result.source = props.source
   result.repeat = props.repeat
-  result.width = map(lambda x: x.get_absolute(props.width), props.image_width)
-  outsets = map(lambda x: x.get_absolute(props.width), props.outset)
+  result.width = [x.get_absolute(props.width) for x in props.image_width]
+  outsets = [x.get_absolute(props.width) for x in props.outset]
   result.size.width = props.size.width + 2*props.width + outsets[1] + outsets[3]
   result.size.height = props.size.height + 2*props.width + outsets[0] + outsets[2]
   result.slice = props.slice
@@ -121,47 +122,47 @@ def normalise(props):
 
 def check_parse(props):
   if not hasattr(props, 'source'):
-    print "missing border-image-source"
+    print("missing border-image-source")
     return False
   if not hasattr(props.size, 'width'):
-    print "missing width"
+    print("missing width")
     return False
   if not hasattr(props.size, 'height'):
-    print "missing height"
+    print("missing height")
     return False
   if not hasattr(props, 'width'):
-    print "missing border-width"
+    print("missing border-width")
     return False
   if not hasattr(props, 'image_width'):
-    print "missing border-image-width"
+    print("missing border-image-width")
     return False
   if not hasattr(props, 'slice'):
-    print "missing border-image-slice"
+    print("missing border-image-slice")
     return False
   if not hasattr(props, 'repeat') or (props.repeat not in ["stretch", "repeat", "round"]):
-    print "missing or incorrect border-image-repeat '" + props.repeat + "'"
+    print("missing or incorrect border-image-repeat '" + props.repeat + "'")
     return False
   if not hasattr(props, 'outset'):
-    print "missing border-image-outset"
+    print("missing border-image-outset")
     return False
 
   return True
 
 def check_normalise(props):
   if not hasattr(props, 'source'):
-    print "missing border-image-source"
+    print("missing border-image-source")
     return False
   if not hasattr(props.size, 'width'):
-    print "missing width"
+    print("missing width")
     return False
   if not hasattr(props.size, 'height'):
-    print "missing height"
+    print("missing height")
     return False
   if not hasattr(props, 'slice'):
-    print "missing border-image-slice"
+    print("missing border-image-slice")
     return False
   if not hasattr(props, 'repeat') or (props.repeat not in ["stretch", "repeat", "round"]):
-    print "missing or incorrect border-image-repeat '" + props.repeat + "'"
+    print("missing or incorrect border-image-repeat '" + props.repeat + "'")
     return False
 
   return True
@@ -180,7 +181,7 @@ class Tile:
 def make_src_tiles():
   tiles = [Tile() for i in range(9)]
 
-  rows = [range(3*i, 3*(i+1)) for i in range(3)]
+  rows = [list(range(3*i, 3*(i+1))) for i in range(3)]
   cols = [[i, i+3, i+6] for i in range(3)]
 
   row_limits_slice = [0, props.slice[3], props.size.width - props.slice[1], props.size.width]
@@ -239,7 +240,7 @@ def compute(props):
     for t in [tiles[i] for i in [3, 4, 5]]:
       t.scale.y = dest_tile_size.height/t.slice.height()
   else:
-    print "Whoops, invalid border-image-repeat value"
+    print("Whoops, invalid border-image-repeat value")
 
   # catch overlapping slices. Its easier to deal with it here than to catch
   # earlier and have to avoid all the divide by zeroes above
@@ -312,34 +313,34 @@ def compute(props):
       dest_tiles[(i+1)*tiles_h-2].dest_size.width -= diff_h
 
   # output the table to simulate the border
-  print "<table>"
+  print("<table>")
   for i in range(tiles_h):
-    print "<col style=\"width: " + str(dest_tiles[i].dest_size.width) + "px;\">"
+    print("<col style=\"width: " + str(dest_tiles[i].dest_size.width) + "px;\">")
   for i in range(tiles_v):
-    print "<tr style=\"height: " + str(dest_tiles[i*tiles_h].dest_size.height) + "px;\">"
+    print("<tr style=\"height: " + str(dest_tiles[i*tiles_h].dest_size.height) + "px;\">")
     for j in range(tiles_h):
       width = dest_tiles[i*tiles_h+j].size.width
       height = dest_tiles[i*tiles_h+j].size.height
       # catch any tiles with negative widths/heights
       # this happends when the total of the border-image-slices > borde drawing area
       if width <= 0 or height <= 0:
-        print "  <td style=\"background: white;\"></td>"
+        print("  <td style=\"background: white;\"></td>")
       else:
-        print "  <td style=\"background-image: " + props.source + "; background-size: " + str(width) + "px " + str(height) + "px; background-position: " + str(dest_tiles[i*tiles_h+j].offset.x) + "px " + str(dest_tiles[i*tiles_h+j].offset.y) + "px;\"></td>"
-    print "</tr>"
-  print "</table>"
+        print("  <td style=\"background-image: " + props.source + "; background-size: " + str(width) + "px " + str(height) + "px; background-position: " + str(dest_tiles[i*tiles_h+j].offset.x) + "px " + str(dest_tiles[i*tiles_h+j].offset.y) + "px;\"></td>")
+    print("</tr>")
+  print("</table>")
 
 
 # start here
 args = sys.argv[1:]
 if len(args) == 0:
-  print "whoops: no source file"
+  print("whoops: no source file")
   exit(1)
 
 
 props = parse(args[0])
 if not check_parse(props):
-  print dir(props)
+  print(dir(props))
   exit(1)
 props = normalise(props)
 if not check_normalise(props):
diff --git a/layout/reftests/fonts/gsubtest/makegsubfonts.py b/layout/reftests/fonts/gsubtest/makegsubfonts.py
index a8aedef0f2..e2e7d5db23 100644
--- a/layout/reftests/fonts/gsubtest/makegsubfonts.py
+++ b/layout/reftests/fonts/gsubtest/makegsubfonts.py
@@ -1,4 +1,5 @@
 
+from __future__ import print_function
 import os
 import textwrap
 from xml.etree import ElementTree
@@ -124,7 +125,7 @@ def makeLookup1():
     		if table.format == 4:
     			table.cmap[cp] = glyphName
     		else:
-    			raise NotImplementedError, "Unsupported cmap table format: %d" % table.format
+    			raise NotImplementedError("Unsupported cmap table format: %d" % table.format)
     	cp += 1
     
     	# tag.fail
@@ -145,7 +146,7 @@ def makeLookup1():
     		if table.format == 4:
     			table.cmap[cp] = glyphName
     		else:
-    			raise NotImplementedError, "Unsupported cmap table format: %d" % table.format
+    			raise NotImplementedError("Unsupported cmap table format: %d" % table.format)
 
         # bump this up so that the sequence is the same as the lookup 3 font
     	cp += 3
@@ -171,7 +172,7 @@ def makeLookup1():
     script = scriptRecord.Script = Script()
     defaultLangSys = script.DefaultLangSys = DefaultLangSys()
     defaultLangSys.FeatureCount = featureCount
-    defaultLangSys.FeatureIndex = range(defaultLangSys.FeatureCount)
+    defaultLangSys.FeatureIndex = list(range(defaultLangSys.FeatureCount))
     defaultLangSys.ReqFeatureIndex = 65535
     defaultLangSys.LookupOrder = None
     script.LangSysCount = 0
@@ -326,7 +327,7 @@ def makeLookup3():
     		if table.format == 4:
     			table.cmap[cp] = glyphName
     		else:
-    			raise NotImplementedError, "Unsupported cmap table format: %d" % table.format
+    			raise NotImplementedError("Unsupported cmap table format: %d" % table.format)
     	cp += 1
     
     	# tag.alt1,2,3
@@ -347,7 +348,7 @@ def makeLookup3():
     			if table.format == 4:
     				table.cmap[cp] = glyphName
     			else:
-    				raise NotImplementedError, "Unsupported cmap table format: %d" % table.format
+    				raise NotImplementedError("Unsupported cmap table format: %d" % table.format)
     		cp += 1
     	
     # set the glyph order
@@ -371,7 +372,7 @@ def makeLookup3():
     script = scriptRecord.Script = Script()
     defaultLangSys = script.DefaultLangSys = DefaultLangSys()
     defaultLangSys.FeatureCount = featureCount
-    defaultLangSys.FeatureIndex = range(defaultLangSys.FeatureCount)
+    defaultLangSys.FeatureIndex = list(range(defaultLangSys.FeatureCount))
     defaultLangSys.ReqFeatureIndex = 65535
     defaultLangSys.LookupOrder = None
     script.LangSysCount = 0
@@ -474,13 +475,13 @@ def makeJavascriptData():
 
 # build fonts
 
-print "Making lookup type 1 font..."
+print("Making lookup type 1 font...")
 makeLookup1()
 
-print "Making lookup type 3 font..."
+print("Making lookup type 3 font...")
 makeLookup3()
 
 # output javascript data
 
-print "Making javascript data file..."
+print("Making javascript data file...")
 makeJavascriptData()
\ No newline at end of file
